"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a;
var os = __importStar(require("os"));
var ISerializeSymbol_1 = require("./ISerializeSymbol");
var TYPES = (_a = {},
    _a[ISerializeSymbol_1.MODIFIER_TYPE.PRIVATE] = '-',
    _a[ISerializeSymbol_1.MODIFIER_TYPE.PROTECTED] = '#',
    _a[ISerializeSymbol_1.MODIFIER_TYPE.PUBLIC] = '+',
    _a);
function convertToPlant(tsjs) {
    var lines = [];
    lines.push('@startuml');
    tsjs.forEach(function (serializedSymbol) {
        var keyword = '';
        if (serializedSymbol.keyword !== undefined) {
            keyword = serializedSymbol.keyword + " ";
        }
        var heritage = '';
        if (serializedSymbol.extends !== undefined) {
            heritage += " extends " + serializedSymbol.extends;
        }
        var serializedClass = serializedSymbol;
        if (serializedClass.implements !== undefined) {
            heritage += " implements " + serializedClass.implements.join(', ');
        }
        var parameters = '';
        if (serializedClass.parameters !== undefined && serializedClass.parameters.length > 0) {
            parameters = "<" + serializedClass.parameters.map(function (parameter) { return parameter.name; })
                .join(', ') + ">";
        }
        var openingBrace = '';
        if (serializedSymbol.members.length > 0) {
            openingBrace = ' {';
        }
        lines.push("" + keyword + serializedSymbol.structure + " " + serializedSymbol.name + parameters + heritage + openingBrace);
        for (var _i = 0, _a = serializedSymbol.members; _i < _a.length; _i++) {
            var serializedMember = _a[_i];
            lines.push(memberToString(serializedMember));
        }
        if (serializedSymbol.members.length > 0) {
            lines.push('}');
        }
    });
    lines.push('@enduml');
    return lines.join(os.EOL);
    function memberToString(member) {
        var line = "    ";
        if (typeof member === 'string') {
            line += member;
            return line;
        }
        line += TYPES[member.modifierType];
        if (member.keyword !== undefined) {
            line += "{" + member.keyword + "} ";
        }
        line += member.name;
        if (member.type === ISerializeSymbol_1.MEMBER_TYPE.METHOD) {
            line += '(';
            line += member.parameters.map(function (parameter) {
                return parameter.name + ": " + parameter.type;
            })
                .join(', ');
            line += ')';
        }
        if (member.returnType !== undefined) {
            line += ": " + member.returnType;
        }
        return line;
    }
}
exports.convertToPlant = convertToPlant;
